# -*- coding:utf-8 -*-  

import os 
import sys 
import xlwt
import datetime

default_encoding = 'utf-8'
if sys.getdefaultencoding() != default_encoding:
    #print sys.getdefaultencoding()
    reload(sys)
    sys.setdefaultencoding(default_encoding)


if __name__=='__main__':
    startTime = datetime.datetime.now()
    
    #参数限制，需要一个参数输入txt的路径 
    if len(sys.argv)!=2:
        print "%s 脚本需要输入待转换txt文件的路径！" %sys.argv[0]
        sys.exit(0)

    #获取python脚本第一个输入参数，即txt文件的保存路径
    path=os.path.join(os.getcwd(), sys.argv[1])  
  
    if not os.path.exists(path):  
        print "ERROR: %s can not find" %path  
        sys.exit(1)  

    #在txt的同一目录下创建xls文件
    xlsxPath = os.path.join(os.path.dirname(path),   
        os.path.splitext(os.path.basename(path))[0] + '.xls')  

    #设置xls文件的编码类型
    workbook = xlwt.Workbook(encoding='utf-8')    
    
    #每次从txt中读取的大小。
    BUFSIZE = 1024
    #表格最大行数限制。
    EXCEL_ROWS = 65535
    #设置表格最大的列数限制。 
    EXCEL_COLS = 256 
    #需要查看txt文档中每行字符串间分隔符，选择不同的分隔符才能控制每行内容的拆分。
    FIELD_SEPARATOR = '\t'

    with open(path, 'r') as f:  
        nrows, total_rows = 0, 0
        #从txt中每次读取一行，并限制大小
        lines = f.readlines(BUFSIZE)  
        while lines:
            for line in lines:
                #判断当前的xls行数是否已经超过限制行数
                if (nrows % EXCEL_ROWS == 0) :
                    #当行数已经超过最大行数限制时，新建一个表格用于继续写入
                    wsheet = workbook.add_sheet('sheet' + str(total_rows), cell_overwrite_ok = True)  
                    nrows = 0

                #处理读取的txt行的信息
                values = line.split(FIELD_SEPARATOR)
                print "%s" %values
                #比较读取的txt每行字符处理后得到的数量是否超过列数限制，超过的则不会写入表格
                cols_num = EXCEL_COLS if len(values) > EXCEL_COLS else len(values)

                #循环写入表格每行
                for ncol in xrange(cols_num):
                    print "%s" %values[ncol]
                    wsheet.write(nrows, ncol, values[ncol])
                nrows = nrows + 1
                total_rows = total_rows + 1

            lines = f.readlines(BUFSIZE)
    #保存写好的表格          
    workbook.save(xlsxPath)
    #计算整个转换消耗时间
    endTime = datetime.datetime.now()
    print "spend time %s seconds" %((endTime - startTime).seconds)
